#<profile4xi profile = "32" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "process4xi.py">
#<abstract4xi abstract = "provides Process4Xi class"/>
#<refer4xi reference = "process.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = ['Process4Xi'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
try:                 # system ones
    import os
    import sys
    import signal
except:
    pass
try:                 # threading ones       
    import threading                
    import _thread   
except:
    pass
try:                 # winapi
    import _winapi
    from _winapi import WAIT_OBJECT_0, WAIT_TIMEOUT, INFINITE
except ImportError:
    if sys.platform == 'win32':
        raise
    _winapi = None
            
try:                 
    import itertools         
except:
    pass
try:                 
    from functools import partial          
except:
    pass 
try:  
   from _weakrefset import WeakSet    
except:
    pass           
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
try:                             # Binary ones
    import _multiprocessing
except:
    pass
try:                             # Python ones
    from multiprocessing import forking
    from multiprocessing import process
    from multiprocessing.process import Process
except:
    pass
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from active_children4xi import active_children4xi
from after_fork4xi import AfterFork4Xi

from constant_family4xi import ConstantFamily4Xi
from constant_process4xi import ConstantProcess4Xi
from current_process4xi import CurrentProcess4Xi
from current_process4xi import get_current_process4xi
from current_process4xi import get_authkey_current_process4xi
from current_process4xi import get_identity_current_process4xi
from current_process4xi import get_name_current_process4xi
from current_process4xi import get_counter_current_process4xi
from current_process4xi import get_daemonic_current_process4xi
from current_process4xi import get_tempdir_current_process4xi
from current_process4xi import add_child_current_process4xi
from current_process4xi import get_children_current_process4xi
from current_process4xi import discard_child_current_process4xi
from current_process4xi import list_children_current_process4xi

from examine4xi import examine4xi

from finalizer4xi import init_finalizer_registry4xi
from finalizer4xi import Finalizer4Xi
from finalizer4xi import clear_finalizer_registry4xi
from forkingpickler4xi import ForkingPickler4Xi

from is_exiting4xi import init_exiting4xi
from is_exiting4xi import get_exiting4xi

from original_dir4xi import init_original_dir4xi
from original_dir4xi import get_original_dir4xi

from popen4xi import Popen4Xi
from print4xi import print4xi

from reason_object4xi import reason_object4xi

from sense_object4xi import sense_object4xi
from sleep4xi import omega2sleep4xi

from timeout4xi import omega2timeout4xi
from time4xi import time4xi    

from _exit_function4xi import _exit_function4xi
#"
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "rebuild-partial4xi" usage = "
#   rebuilds partial
#"> 
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _rebuild_partial4xi(func, args, keywords):

    '''
    rebuilds partial
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        

    class2print = "_rebuild_partial4xi"
    method2print = "_rebuild_partial4xi"
                  
    message2print = "{started" + "; rebuild-partial4xi-started: " + str(_rebuild_partial4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
       
    message2print = "{passed" + "; func-passed-to-rebuild-partial4xi: " + str(func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; args-passed-to-rebuild-partial4xi: " + str(args) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
    
    message2print = "{passed" + "; keywords-passed-to-rebuild-partial4xi: " + str(keywords) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
     
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; func-passing-to-partial-by-rebuild-partial4xi: " + str(func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
   
    message2print = "{returning" + "; partial-function-returning-by-rebuild-partial4xi: " + str(partial) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
               
        
    return partial(func, *args, **keywords)

#</function4xi>
# -----------------------------------------------------------------------------------------    
#<function4xi function = "reduce-partial4xi" usage = "
#   forking.py
#       ForkingPickler.register(partial, _reduce_partial)
#"> 
#<refer4xi reference = "forking.py"/>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -----------------------------------------------------------------------------------------        
def _reduce_partial4xi(p):
    '''
    reduces partial
    '''
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    class2print = "_reduce_partial4xi"
    method2print = "_reduce_partial4xi"
  

    message2print = "{started" + "; reduce-partial4xi-started: " + str(_reduce_partial4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
                 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; p-func-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.func) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
    
    message2print = "{passing" + "; p-args-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.args) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
           
    message2print = "{passing" + "; p-keywords-passing-to-rebuild-partial4xi-by-reduce-partial4xi: " + str(p.keywords or {}) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)
    
    message2print = "{returning" + "; rebuild-partial4xi-function-returning-by-reduce-partial4xi: " + str(_rebuild_partial4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
                      
       
    return _rebuild_partial4xi, (p.func, p.args, p.keywords or {})

    # -----------------------------------------------------------------------------------------    
    #
    # ----------------------------------------------------------------------------------------- 
           
#</function4xi>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "cleanup4xi" usage = "
#     process.py
#         _cleanup()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def _cleanup4xi():

    '''
    checks for processes which have finished
    '''

    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------
          
    class2print = "_cleanup4xi"
    method2print = "_cleanup4xi"

    
    message2print = "{started" + "; cleanup4xi-started: " + str(_cleanup4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
     
    
    # check for processes which have finished
    
    for childprocess2xi in list(get_children_current_process4xi()):             # dragonized _current_process._children):
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        
        message2print = "{got" + "; childprocess2xi-got-by-cleanup4xi: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                        
                
    
        if childprocess2xi._popen.poll() is not None:
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            message2print = "{passing" + "; childprocess2xi-passing-to-discard-child-current-process4xi-by-cleanup4xi: " + str(childprocess2xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
                    
            discard_child_current_process4xi(childprocess2xi)              # dragonized _current_process._children.discard(p2xi)
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                
            message2print = "{performed" + "; discard-child-current-process4xi-performed-by-cleanup4xi: " + str(discard_child_current_process4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                        


    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------                    
    message2print = "{returning" + "; cleanup4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                  
           
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "run-finalizers4xi" usage = "
# _exit_function():
#     _run_finalizers(0)<--- min priority 0
#     _run_finalizers() <--- min priority None
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _run_finalizers4xi(minpriority=None):
    '''
    runs all finalizers whose exit priority is not None and at least minpriority

    - finalizers with highest priority are called first; finalizers with
    the same priority will be called in reverse order of creation
    '''
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------        
        
    class2print = "_run_finalizers4xi"
    method2print = "_run_finalizers4xi"

    import finalizer4xi
    
    message2print = "{(Step 1/7a) started" + "; run-finalizers4xi-started: " + str(_run_finalizers4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
        
    message2print = "{(Step 1/7b) passed" + "; minpriority-passed-to-run-finalizers4xi: " + str(minpriority) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
         
    
    # -----------------------------------------------------------------------------------------    
    # (Step 2/7)
    # -----------------------------------------------------------------------------------------        
       
    if minpriority is None:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
          
        f = lambda p : p[0][0] is not None
        
        message2print = "{(Step 2/7a) set" + "; f-set-by-run-finalizers4xi to: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
    else:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
          
        f = lambda p : p[0][0] is not None and p[0][0] >= minpriority
        
        message2print = "{(Step 2/7b) set" + "; f-set-by-run-finalizers4xi to: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
       
         
        
    # -----------------------------------------------------------------------------------------    
    # (Step 3/7)
    # -----------------------------------------------------------------------------------------    
    items = [x for x in list(finalizer4xi._finalizer_registry.items()) if f(x)]
    
    message2print = "{(Step 3/7) set" + "; items-set-by-run-finalizers4xi to: " + str(items)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
     
    # -----------------------------------------------------------------------------------------    
    # (Step 4/7)
    # -----------------------------------------------------------------------------------------        
    items.sort(reverse=True)
    
    message2print = "{(Step 4/7) performed" + "; items-sort-performed-by-run-finalizers4xi: " + str(items.sort) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
               
     
    # -----------------------------------------------------------------------------------------    
    # (Step 5/7)
    # -----------------------------------------------------------------------------------------    
    for key, finalizer in items:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
          
        # calling finalizer
        
        message2print = "{(Step 5/7a) got" + "; key-got-by-run-finalizers4xi: " + str(key)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
                
        message2print = "{(Step 5/7b) calling" + "; finalizer-calling-by-run-finalizers4xi: " + str(finalizer) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
              
        try:
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            finalizer()
            
            message2print = "{(Step 5/7c) performed" + "; finalizer-performed-by-run-finalizers4xi: " + str(finalizer) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                    
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                        
        except Exception:
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
            
            import traceback
            traceback.print_exc()
            
            message2print = "{(Step 5/7d) hit" + "; key-hit-by-run-finalizers4xi: " + " *** " + str(key)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
        
            
            message2print = "{(Step 5/7e hit" + "; finalizer-hit-by-run-finalizers4xi: " + " *** " + str(finalizer)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
   
            # -------------------------------------------------------------------------------------    
            #
            # -------------------------------------------------------------------------------------     
                    
         
             
    # -----------------------------------------------------------------------------------------    
    # (Step 6/7)
    # -----------------------------------------------------------------------------------------              
    if minpriority is None:
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        
        message2print = "{(Step 6/7a) calling" + "; clear-finalizer-registry4xi-calling-by-run-finalizers4xi: " + str(clear_finalizer_registry4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
            
        clear_finalizer_registry4xi()
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
              
        message2print = "{(Step 6/7b) performed" + "; clear-finalizer-registry4xi-performed-by-run-finalizers4xi: " + str(clear_finalizer_registry4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
     
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                
    
        
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------                   
    message2print = "{(Step 7/7) returning" + "; run-finalizers4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)         
#</function4xi>

# =================================================================================================
#<class4xi class = "C" base = "None" child = "None" synopsis = "C class" usage = "
#     forking.py
#         ForkingPickler.register(type(_C().f), _reduce_method)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================       
class _C:
    '''
    _C class: forking.py: ForkingPickler.register(type(_C().f), _reduce_method)
    
    '''
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "f" usage = "f method">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def f(self):
        '''
        acts as a dummy function
        '''
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                
        class2print = "_C"
        method2print = "f"
    
        message2print = "{started" + "; f-of-C-started: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
         
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
    
        pass
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{returning" + "; f-of-C-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                                
                        
                                              
    #</methodize4xi>
#</class4xi>


# =================================================================================================
#<class4xi class = "C4Xi" base = "None" child = "None" synopsis = "C4Xi class" usage = "
#     forking4xi.py
#         ForkingPickler4Xi.register(type(_C4Xi().f), _reduce_method)
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================                 
class _C4Xi: #<--- note that this class has no ()
    '''
    pickling
    '''
    

      
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "f" usage = "f method">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def f(self):
        '''
        f method
        '''
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                
        class2print = "_C4Xi"
        method2print = "f"

    
        message2print = "{started" + "; f-of-C4Xi-started: " + str(f)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                 
        
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
            
        pass
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------              
        message2print = "{returning" + "; f-of-C4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                        
                
                        
    #</methodize4xi>
              
                
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-C4Xi" usage = "senses _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        senses _C4Xi class objects
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
          
        
        class2print = '_C4Xi' 
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; C4Xi-sensing-by-sense-of-C4Xi: " + str(_C4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; knowledge-base2xi-got-by-sense-of-C4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
    
        
        
      
        message2print = "{sensed" + "; C4Xi-sensed-by-sense-of-C4Xi: " + str(_C4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; knowledge-base2xi-returning-by-sense-of-C4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                             
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-C4Xi" usage = "reasons _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        reasons _C4Xi class objects
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
                 
        
        class2print = '_C4Xi'
        method2print = 'reason'

        
        message2print = "{started" + "; reason-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
    
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; C4Xi-reasoning-by-reason-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; knowledge-base4xi-got-by-reason-of-C4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; C4Xi-reasoned-by-reason-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; knowledge-base4xi-returning-by-reason-of-C4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                        
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-C4Xi" usage = "aces _C4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces _C4Xi class objects 
        '''

        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        class2print = '_C4Xi'
        method2print = 'ace'
        
        message2print = "{started" + "; ace-of-C4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
            
   
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; C4Xi-acing-by-ace-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                   
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; knowledge-base8xi-got-by-ace-of-C4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; C4Xi-aced-by-ace-of-C4Xi: " + str(_C4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)           
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8x-returning-by-ace-of-C4Xi: " + str(kb8x) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                            
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce-method-descriptor4xi" usage = "
#   forking.py
#       ForkingPickler.register(type(list.append), _reduce_method_descriptor)   
#       ForkingPickler.register(type(list.append), _reduce_method_descriptor)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def _reduce_method_descriptor4xi(m):
    '''
    reduces method descriptor
    ''' 
    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    class2print = "_reduce_method_descriptor4xi"
    method2print = "_reduce_method_descriptor4xi"
   
    
    message2print = "{started" + "; reduce-method-descriptor4xi-started: " + str(_reduce_method_descriptor4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    message2print = "{passed" + "; m-passed-to-reduce-method-descriptor4xi: " + str(m) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                    
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
    message2print = "{passing" + "; m-objclass-passing-to-getattr-by-reduce-method-descriptor4xi: " + str(m.__objclass__) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)          
        
    message2print = "{passing" + "; m-name-passing-to-getattr-by-reduce-method-descriptor4xi: " + str(m.__name__) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)              

    message2print = "{returning" + "; getattr-function-returning-by-reduce-method-descriptor4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print) 
            
           
    return getattr, (m.__objclass__, m.__name__)    
    
#</function4xi>


# ---------------------------------------------------------------------------------------------
#<function4xi function = "exit-function4xi" usage = "
#     util.py
#         atexit.register(_exit_function)
# process4xi.py:
#     _bootstrap:
#         _exit_function4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def _exit_function4xi():

    '''
    exists
    '''

    # -----------------------------------------------------------------------------------------    
    # (Step 1/8): OK
    # -----------------------------------------------------------------------------------------        
 
    class2print = "_exit_function4xi"
    method2print = "_exit_function4xi"
    
    message2print = "{(Step 1/8) started" + "; exit-function4xi-started: " + str(_exit_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    
    
    # { _exit_function4xi : _exit_function4xi ; Step 1/5 start time: 15:23:40 09/02/09 FLE Daylight Time}
    

    
    # -----------------------------------------------------------------------------------------
    # (Step 2/8): OK
    # -----------------------------------------------------------------------------------------    
    set_exiting4xi(True)        #dragonized; added here
    
    message2print = "{(Step 2/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        
    # { _exit_function4xi : _exit_function4xi ; Step 2/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
    
    # process shutting down
    # running all atexit finalizers with priority >= 0

    # { _exit_function4xi : _exit_function4xi ; Step 2/5b inform: process shutting down; time: 15:23:40 09/02/09 FLE Daylight Time} 
    # { _exit_function4xi : _exit_function4xi ; Step 2/5c inform: running finalizers ; time: 15:23:40 09/02/09 FLE Daylight Time}
        
    # -----------------------------------------------------------------------------------------
    # (Step 3/8): OK partly; no active children in tests so far
    # -----------------------------------------------------------------------------------------    
    
    _run_finalizers4xi(0)
    
    
    message2print = "{(Step 3/8) performed" + "; run-finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
       
       
    #{ _exit_function4xi : _exit_function4xi ; Step 3/5a performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
        
    # -----------------------------------------------------------------------------------------    
    # (Step 4/8): 
    # -----------------------------------------------------------------------------------------        

    for childprocess2xi in active_children4xi():
    
        message2print = "{(Step 4/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
    
        if childprocess2xi._daemonic:
            # calling terminate() for daemon 
            
            message2print = "{(Step 4/8b) calling" + "; childprocess2xi-popen-terminate-calling-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
                    
            childprocess2xi._popen.terminate()

            message2print = "{performed" + "; childprocess2xi-popen-terminate-performed-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                                
    # -----------------------------------------------------------------------------------------    
    # (Step 5/8): 
    # -----------------------------------------------------------------------------------------        

            
    for childprocess2xi in active_children4xi():
    
        message2print = "{(Step 5/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
       
    
        # calling join() for process
        
            
        message2print = "{(Step 5/8b) calling" + "; childprocess2xi-join-calling-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        childprocess2xi.join()

        message2print = "{performed" + "; childprocess2xi-join-performed-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    

            
    # -----------------------------------------------------------------------------------------
    # (Step 6/8): OK 
    # -----------------------------------------------------------------------------------------        
    
    # running the remaining atexit finalizers
    
    _run_finalizers4xi()

    
    message2print = "{(Step 6/8) performed" + "; run_finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 4/5 performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 7/8): OK
    # ---------------------------------------------------------------------------------------------    

    
    set_exiting4xi(False)       #dragonized; added here
    
    
    message2print = "{(Step 7/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 5/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time}    
    # { _exit_function4xi : _exit_function4xi ; Step 5/5b returning time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 8/8): OK
    # ---------------------------------------------------------------------------------------------    
    message2print = "{(Step 8/8) returning" + "; exit-function4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    

            
#</function4xi>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "reduce-method4xi" usage = "
#     forking.py 
#         ForkingPickler.register(type(_C().f), _reduce_method)
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------        
def _reduce_method4xi(m):
    '''
    reduces method
    '''
        
    # -----------------------------------------------------------------------------------------    
    # (Step 1/2) 
    # -----------------------------------------------------------------------------------------        
       
    class2print = "_reduce_method4xi"
    method2print = "_reduce_method4xi"
    
    message2print = "{(Step 1/2a) started" + "; reduce-method4xi-started: " + str(_reduce_method4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
       
    message2print = "{(Step 1/2b) passed" + "; method-passed-to-reduce-method4xi: " + str(m) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------        
   
    
    if m.__self__ is None:
        
        # -------------------------------------------------------------------------------------    
        # (Step 2/2a) 
        # -------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2a1) passing" + "; method-class-passing-to-getattr-by-reduce-method4xi: " + str(m.__class__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 2/2a2) passing" + "; function-name-passing-to-getattr-by-reduce-method4xi: " + str(func__.__name__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
       
        message2print = "{(Step 2/2a3) returning" + "; getattr-function-returning-by-reduce-method4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
                
        return getattr, (m.__class__, m.__func__.__name__)
    else:

        
        # -------------------------------------------------------------------------------------    
        # (Step 2/2b) 
        # -------------------------------------------------------------------------------------        
        message2print = "{(Step 2/2b1) passing" + "; method-pointer-passing-to-getattr-by-reduce-method4xi: " + str(m.__self__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        message2print = "{(Step 2/2b2) passing" + "; method-function-name--passing-to-getattr-by-reduce-method4xi: " + str(m.__func__.__name__) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                  
       
        message2print = "{(Step 2/2b3) returning" + "; getattr-function-returning-by-reduce-method4xi: " + str(getattr) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
               

        return getattr, (m.__self__, m.__func__.__name__)

#</function4xi>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "run-after-forkers4xi" usage = "
#   managers.py: 
#       util._run_after_forkers()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
#
def _run_after_forkers4xi():
    '''
    supports re-initialization of objects when bootstrapping a child process
    '''    
    
    # -----------------------------------------------------------------------------------------    
    # (Step 1/7)
    # -----------------------------------------------------------------------------------------       

    class2print = "_run_after_forkers4xi"
    method2print = "_run_after_forkers4xi"

    from after_fork4xi import _afterfork_counter
    from after_fork4xi import _afterfork_registry        
    
    message2print = "{(Step 1/7) started" + "; run-after-forkers4xi-started: " + str(_run_after_forkers4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
      
    
    # -----------------------------------------------------------------------------------------    
    # (Step 2/7)
    # -----------------------------------------------------------------------------------------        
    items = list(_afterfork_registry.items())
    
    message2print = "{(Step 2/7) set" + "; items-set-by-run-after-forkers4xi to: " + str(items)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)  
                
    
    # -----------------------------------------------------------------------------------------    
    # (Step 3/7)
    # -----------------------------------------------------------------------------------------       
    
    items.sort()
    
    message2print = "{(Step 3/7) performed" + "; items-sort-performed-by-run-after-forkers4xi: " + str(items.sort) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
                
    
    # -----------------------------------------------------------------------------------------    
    # (Step 4/7)
    # -----------------------------------------------------------------------------------------       
    for (index, ident, func), obj in items:
    
        message2print = "{(Step 4/7a) got" + "; index-got-by-run-after-forkers4xi: " + str(index)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7b) got" + "; ident-got-by-run-after-forkers4xi: " + str(ident)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7c) got" + "; func-got-by-run-after-forkers4xi: " + str(func)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
    
        message2print = "{(Step 4/7d) got" + "; object-got-by-run-after-forkers4xi: " + str(obj)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                            
        
        try:
            
            
            # ---------------------------------------------------------------------------------    
            # (Step 5/7)
            # ---------------------------------------------------------------------------------         
            message2print = "{(Step 5/7a) passing" + "; object-passing-to-func-by-run-after-forkers4xi: " + str(obj) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
         
      
        
            func(obj)
            
            message2print = "{(Step 5/7b) performed" + "; func-performed-by-run-after-forkers4xi: " + str(func) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                       
      
            
        except Exception as e:

            
            # ---------------------------------------------------------------------------------    
            # (Step 6/7)
            # ---------------------------------------------------------------------------------         
            info4xi('_run_after_forkers4xi: after forker raised exception %s', e)
            
            message2print = "{(Step 6/7) hit" + "; Exception-hit-by-run-after-forkers4xi: " + " *** " + str(e)  + " *** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
                    
                    
         
            
    # -----------------------------------------------------------------------------------------    
    # (Step 7/7)
    # -----------------------------------------------------------------------------------------                   
    message2print = "{(Step 7/7) returning" + "; run-after-forkers4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)      
                   
#</function4xi>
# ---------------------------------------------------------------------------------------------
#<function4xi function = "exit-function4xi" usage = "
#     util.py
#         atexit.register(_exit_function)
# process4xi.py:
#     _bootstrap:
#         _exit_function4xi()
#"> 
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# ---------------------------------------------------------------------------------------------
def _exit_function4xi():

    '''
    exists
    '''

    # -----------------------------------------------------------------------------------------    
    # (Step 1/8): OK
    # -----------------------------------------------------------------------------------------        
 
    class2print = "_exit_function4xi"
    method2print = "_exit_function4xi"
    
    message2print = "{(Step 1/8) started" + "; exit-function4xi-started: " + str(_exit_function4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 

    from is_exiting4xi import set_exiting4xi
    from is_exiting4xi import get_exiting4xi
    

    
    # -----------------------------------------------------------------------------------------
    # (Step 2/8): OK
    # -----------------------------------------------------------------------------------------    
    set_exiting4xi(True)        #dragonized; added here
    
    message2print = "{(Step 2/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
        
    # { _exit_function4xi : _exit_function4xi ; Step 2/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
    
    # process shutting down
    # running all atexit finalizers with priority >= 0

    # { _exit_function4xi : _exit_function4xi ; Step 2/5b inform: process shutting down; time: 15:23:40 09/02/09 FLE Daylight Time} 
    # { _exit_function4xi : _exit_function4xi ; Step 2/5c inform: running finalizers ; time: 15:23:40 09/02/09 FLE Daylight Time}
        
    # -----------------------------------------------------------------------------------------
    # (Step 3/8): OK partly; no active children in tests so far
    # -----------------------------------------------------------------------------------------    
    
    _run_finalizers4xi(0)
    
    
    message2print = "{(Step 3/8) performed" + "; run-finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
       
       
    #{ _exit_function4xi : _exit_function4xi ; Step 3/5a performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time} 
        
    # -----------------------------------------------------------------------------------------    
    # (Step 4/8): 
    # -----------------------------------------------------------------------------------------        

    for childprocess2xi in active_children4xi():
    
        message2print = "{(Step 4/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
    
        if childprocess2xi._daemonic:
            # calling terminate() for daemon 
            
            message2print = "{(Step 4/8b) calling" + "; childprocess2xi-popen-terminate-calling-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
                    
            childprocess2xi._popen.terminate()

            message2print = "{performed" + "; childprocess2xi-popen-terminate-performed-by-exit-function4xi: " + str(childprocess2xi._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
                                
    # -----------------------------------------------------------------------------------------    
    # (Step 5/8): 
    # -----------------------------------------------------------------------------------------        

            
    for childprocess2xi in active_children4xi():
    
        message2print = "{(Step 5/8a) got" + "; childprocess2xi-got-by-exit-function4xi to: " + str(childprocess2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
       
    
        # calling join() for process
        
            
        message2print = "{(Step 5/8b) calling" + "; childprocess2xi-join-calling-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        childprocess2xi.join()

        message2print = "{performed" + "; childprocess2xi-join-performed-by-exit-function4xi: " + str(childprocess2xi.join) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
    

            
    # -----------------------------------------------------------------------------------------
    # (Step 6/8): OK 
    # -----------------------------------------------------------------------------------------        
    
    # running the remaining atexit finalizers
    
    _run_finalizers4xi()

    
    message2print = "{(Step 6/8) performed" + "; run_finalizers4xi-performed-by-exit-function4xi: " + str(_run_finalizers4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 4/5 performed: _run_finalizers4xi; time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 7/8): OK
    # ---------------------------------------------------------------------------------------------    

    
    set_exiting4xi(False)       #dragonized; added here
    
    
    message2print = "{(Step 7/8) performed" + "; set-exiting4xi-performed-by-exit-function4xi: " + str(set_exiting4xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)             
         
    # { _exit_function4xi : _exit_function4xi ; Step 5/5a performed: set_exiting4xi; time: 15:23:40 09/02/09 FLE Daylight Time}    
    # { _exit_function4xi : _exit_function4xi ; Step 5/5b returning time: 15:23:40 09/02/09 FLE Daylight Time}
     
    # ---------------------------------------------------------------------------------------------
    # (Step 8/8): OK
    # ---------------------------------------------------------------------------------------------    
    message2print = "{(Step 8/8) returning" + "; exit-function4xi-returning: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)    

            
#</function4xi>
# -------------------------------------------------------------------------------------------------
#<function4xi function = "active_children4xi" usage = "
#     managers.py:
#         for p in active_children():
#">
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/> 
# -------------------------------------------------------------------------------------------------
def active_children4xi():
    '''
    returns list of process objects corresponding to live child processes
    '''
           
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
        
    class2print = 'active_children4xi'
    method2print = 'active_children4xi'
    
    # message2print = "{started" + "; active-children4xi-started: " + str(active_children4xi)  + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)   

               
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
    
    # message2print = "{calling" + "; cleanup-calling-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)       
            
    _cleanup4xi()

    
    # message2print = "{performed" + "; cleanup-performed-by-active-children4xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
    # print4xi(class2print, method2print, message2print)       
  
               
    # ---------------------------------------------------------------------------------------------    
    #
    # ---------------------------------------------------------------------------------------------   
        
    # message2print = "{returning" + "; list-children-current-process4xi-function-returning-by-active-children4xi: " + str(list_children_current_process4xi) + "; time: " + time4xi() + "}" 
    # print4xi(class2print, method2print, message2print)      

   
    
    return list_children_current_process4xi() #dragonized
#</function4xi>

# =================================================================================================
#<class4xi class = "Process4Xi" base = "object" child = "None" synopsis = "represent activity that is run in a separate process" usage = "
#   Objects represent activity that is run in a separate process and in multi-core CPU in a separate core simultaneously with other processes
#   It has equivalents of all the methods of threading.Thread.  More: python.org
#                    
#
#   after_fork4xi.py:
#       p2xi = Process4Xi()
#
#   basemanager4xi.py
#       self._process = Process4Xi(target=type(self)._run_server,args=(self._registry, self._address, self._authkey,self._serializer, writer),)
#"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
#
class Process4Xi(object):
    '''
    Process4Xi objects represent activity that is run in a separate process
    and is analagous to threading.Thread
    '''
    
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('run', 'start', 'terminate',
                 'join', 'is_alive',
                 'sense', 'reason', 'ace')          
    #"
    #/>    

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    #     process.py:
    #         start:
    #             if self._Popen is not None:
    #                 Popen = self._Popen
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    _Popen = None
    _cf2xi = ConstantFamily4Xi()
    _constant_p2xi = ConstantProcess4Xi()
    _ack2current = False
    _nack2current = True
    #"
    #/>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-Process4Xi" usage = "
    #    parameters:
    #           1. group should always be None; it exists solely for compatibility with Thread. 
    #           2. target is the callable object to be invoked by the run() method. It defaults to None, meaning nothing is called. 
    #           3. name is the process name. 
    #              By default, a unique name is constructed of the form Process-N1:N2:...:Nk 
    #              where N1,N2,...,Nk is a sequence of integers whose length is determined by the generation of the process. 
    #           4. args is the argument tuple for the target invocation. 
    #           5. kwargs is a dictionary of keyword arguments for the target invocation. By default, no arguments are passed to target.
    #              The constructor should always be called with keyword arguments! 
    #    notes:
    #           If a subclass overrides the constructor, it must make sure it invokes the base class constructor (Process.__init__()) before doing anything else to the process.">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __init__(self, group=None, target=None, name=None, args=(), kwargs={}, *, daemon=None):
        '''
        initializes Process4Xi
        '''
        
        class2print = "Process4Xi"
        method2print = "__init__"  

        # -----------------------------------------------------------------------------------------
        # (Step 0/15) - ACK4HW
        # -----------------------------------------------------------------------------------------       
        message2print = "{(Step 0/15a) started" + "; init-of-Process4Xi-started: "  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 05:35:38 01/16/13 Pacific Standard Time
        
        message2print = "{(Step 0/15b) borning" + "; process2xi-of-Process4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # 05:35:38 01/16/13 Pacific Standard Time
                           
                    
        message2print = "{(Step 0/15c) passed" + "; group-passed-to-init-of-Process4Xi: " + str(group) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # None
        
        message2print = "{(Step 0/15d) passed" + "; target-passed-to-init-of-Process4Xi: " + str(target) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <function worker4xi at 0x0000000003800D90>
        
        message2print = "{(Step 0/15e) passed" + "; name-passed-to-init-of-Process4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # None
        
        message2print = "{(Step 0/15f) passed" + "; args-passed-to-init-of-Process4Xi: " + str(args) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # (<simplequeue4xi.SimpleQueue4Xi object at 0x0000000003A1A240>, <simplequeue4xi.SimpleQueue4Xi object at 0x0000000003A1A2E8>, None, (), None)

        
        message2print = "{(Step 0/15g) passed" + "; kwargs-passed-to-init-of-Process4Xi: " + str(kwargs) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # {}

        message2print = "{(Step 0/15h) passed" + "; daemon-passed-to-init-of-Process4Xi: " + str(daemon) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # None
        
        message2print = "{(Step 0/15i) sharing" + "; Popen-sharing-by-process2xi-of-Process4Xi: " + str(Process4Xi._Popen)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
        # None
        
        message2print = "{(Step 0/15j) inheriting" + "; object-inheriting-by-process2xi-of-Process4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'object'>
                                          
        if examine4xi(class2print, method2print):
        
            # -----------------------------------------------------------------------------------------
            # StepOriginal: OK  (original _multiprocessing)     
            # -----------------------------------------------------------------------------------------        
            message2print = "{(Step 0/15k) passing" + "; group-passing-to-Process-init-by-init-of-Process4Xi: " + str(group) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            
            message2print = "{(Step 0/15l) passing" + "; target-passing-to-Process-init-by-init-of-Process4Xi: " + str(target) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                 
            
            message2print = "{(Step 0/15m) passing" + "; name-passing-to-Process-init-by-init-of-Process4Xi: " + str(name) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            message2print = "{(Step 0/15n) passing" + "; args-passing-to-Process-init-by-init-of-Process4Xi: " + str(args) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
            message2print = "{(Step 0/15o) passing" + "; kwargs-passing-to-Process-init-by-init-of-Process4Xi: " + str(kwargs) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                         
            # { Process4Xi : __init__ ; StepOriginal returning by calling original Process.__init__ time: 08:01:24 09/02/09 FLE Daylight Time}
            
            message2print = "{(Step 0/15p) passing" + "; daemon-passing-to-Process-init-by-init-of-Process4Xi: " + str(daemon) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                         
            # 
            
            Process.__init__(self, group=None, target=None, name=None, args=(), kwargs={},daemon=None,)
            
        else:        
            # -----------------------------------------------------------------------------------------
            # (Step 1/15): group       
            # -----------------------------------------------------------------------------------------        
            if group is None: 
            
                message2print = "{(Step 1/15a) accepted" + "; group-accepted-by-init-of-Process4Xi: " + str(group) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                # None
            else:
                message2print = "{(Step 1/15b) yielded" + "; group-yielded-by-init-of-Process4Xi: " + str(group)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                            
                group = None
                
                message2print = "{(Step 1/15c) set" + "; group-set-by-init-of-Process4Xi to: " + str(group)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                                       
            # -----------------------------------------------------------------------------------------
            # (Step 2/15): next counter      
            # -----------------------------------------------------------------------------------------        
            count2xi = next(get_counter_current_process4xi()) 
            
            message2print = "{(Step 2/15) got" + "; count2xi-got-by-init-of-Process4Xi: " + str(count2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 4
               
             
            # -----------------------------------------------------------------------------------------
            # (Step 3/15): setting the identity using that of current process      
            # -----------------------------------------------------------------------------------------
            name2xi = get_name_current_process4xi()
            
            message2print = "{(Step 3/15a) got" + "; name-of-current-process2xi-got-by-init-of-Process4Xi: " + str(name2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # MainProcess4Xi
            
            identity2xi = get_identity_current_process4xi()
            
            message2print = "{(Step 3/15b) got" + "; identity2xi-of-current-process2xi-got-by-init-of-Process4Xi: " + str(identity2xi)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)             
            # ()
            
            self._identity =  identity2xi + (count2xi,)                 #dragonized self._identity = _current_process._identity + (count,)
            
            message2print = "{(Step 3/15c) set" + "; identity-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._identity)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # (4,)
            
            
            # -----------------------------------------------------------------------------------------
            # (Step 4/15): setting the authorization key of the current process      
            # -----------------------------------------------------------------------------------------        
            self._authkey = get_authkey_current_process4xi()                                  # dragonized _current_process._authkey
            
            message2print = "{(Step 4/15) set" + "; authkey-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # b'YZ\x98!c\x0bW#\x1c\xd1\xd5>\x9f\xfez\xc9_(\x82\xe6d\x05\xe5" \xace\xaf\xa3\xac\x8b/'

            # -----------------------------------------------------------------------------------------
            # (Step 5/15): setting daemonic of the current process       
            # -----------------------------------------------------------------------------------------        
            if daemon is not None:
                self._daemonic = daemon                                                       # from parameter
                message2print = "{(Step 5/15a) set" + "; daemonic-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                #  
            else:
                self._daemonic = get_daemonic_current_process4xi()                            # dragonized _current_process._daemonic
            
                message2print = "{(Step 5/15b) set" + "; daemonic-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # False
             
            
            
            # -----------------------------------------------------------------------------------------
            # (Step 6/15): setting  temperary directory of the current process 
            # -----------------------------------------------------------------------------------------
            
            self._tempdir = get_tempdir_current_process4xi()                                  # dragonized _current_process._tempdir
    
            message2print = "{(Step 6/15) set" + "; tempdir-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._tempdir)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            # d:\users\ceo4dr~1\appdata\local\temp\pymp-j2d0x7
            
            
            
            # -----------------------------------------------------------------------------------------
            # (Step 7/15): setting the parent process ID of the current process      
            # -----------------------------------------------------------------------------------------
            self._parent_pid = os.getpid()
    
            message2print = "{(Step 7/15) set" + "; parent-pid-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 3368
            
            # -----------------------------------------------------------------------------------------
            # (Step 8/15): setting _popen of the current process    
            # -----------------------------------------------------------------------------------------
            self._popen = None                                                               # init method sets callers self._popen to None
    
            message2print = "{(Step 8/15) set" + "; popen-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # None
            
            
            # -----------------------------------------------------------------------------------------
            # (Step 9/15): setting target function of the current process       
            # -----------------------------------------------------------------------------------------
            self._target = target
    
            message2print = "{(Step 9/15) set" + "; target-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._target)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            # <function worker4xi at 0x0000000003800D90>
            
            # -----------------------------------------------------------------------------------------
            # (Step 10/15): setting args of the current process       
            # -----------------------------------------------------------------------------------------
            self._args = tuple(args)
    
            message2print = "{(Step 10/15) set" + "; args-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._args)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
            # (<simplequeue4xi.SimpleQueue4Xi object at 0x0000000003A1A240>, <simplequeue4xi.SimpleQueue4Xi object at 0x0000000003A1A2E8>, None, (), None)

            # -----------------------------------------------------------------------------------------
            # (Step 11/15): setting kwargs of the current process       
            # -----------------------------------------------------------------------------------------
            self._kwargs = dict(kwargs)
    
            message2print = "{(Step 11/15) set" + "; kwargs-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._kwargs)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)          
            # {}
            
             
            # -----------------------------------------------------------------------------------------
            # (Step 12/15): setting name of the current process       
            # -----------------------------------------------------------------------------------------
            self._name = name or type(self).__name__ + '-' + \
                         ':'.join(str(i) for i in self._identity)
     
            message2print = "{(Step 12/15a) set" + "; name-of-process2xi-set-by-init-of-Process4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # Process4Xi-4
            
            _dangling = None
            try:
                _dangling = WeakSet()
                
                message2print = "{(Step 12/15a) set" + "; dangling-set-by-init-of-Process4Xi to: " + str(_dangling)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # <_weakrefset.WeakSet object at 0x0000000003A1A470>
            except:
                message2print = "{(Step 12/15z1) failed" + "; dangling-failed-by-init-of-Process4Xi to: " + str(_dangling)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                #     
            try:    
                _dangling.add(self)    
                message2print = "{(Step 12/15b) performed" + "; add-performed-by-init-of-Process4Xi to: " + str(_dangling.add)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                # <bound method WeakSet.add of <_weakrefset.WeakSet object at 0x0000000003A1A470>>
            except:
                message2print = "{(Step 12/15z2) failed" + "; add-failed-by-init-of-Process4Xi to: " + str(_dangling)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                      
                #          
                
                        
            # -----------------------------------------------------------------------------------------
            # (Step 13/15): initialize original directory       
            # -----------------------------------------------------------------------------------------
            init_original_dir4xi()                                                                     # dragonized; added this initialization
    
            message2print = "{(Step 13/15) set" + "; original-dir-set-by-init-of-Process4Xi to: " + str(get_original_dir4xi())  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # E:\SW4XI\Python33\Lib\multiprocessing4xi
            
            
            # -------------------------------------------------------------------------------------
            # (Step 14/15): info 
            # -------------------------------------------------------------------------------------
            message2print = "{(Step 14/15a) activated" + "; process2xi-of-Process4Xi-activated: " + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 05:35:38 01/16/13 Pacific Standard Time
          
            message2print = "{(Step 14/15b) shared" + "; Popen-shared-by-process2xi-of-Process4Xi: " + str(Process4Xi._Popen)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                      
            # None
            
            message2print = "{(Step 14/15c) inherited" + "; object-inherited-by-process2xi-of-Process4Xi: " + str(object)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)         
            # <class 'object'>
                   
            # -------------------------------------------------------------------------------------
            # (Step 15/15): returning 
            # -------------------------------------------------------------------------------------                             
            omega2sleep4xi(class2print ,method2print)            # dragonized giving time to others 
            
            message2print = "{(Step 15/15d) returning" + "; init-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 
            
    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "run-of-Process4Xi" usage = "
    #   1. Represents the process activity.
    #   2. YOU MAY OVERRIDE THIS METHOD IN A SUBCLASS - see syncmanager4xi.py with server 
    #   3. The standard run method invokes the callable object passed to the objects constructor as the target argument, if any, 
    #      with sequential and keyword arguments taken from the args and kwargs arguments, respectively.
    #   4. read more at python.org
    #   5. _bootstrap function of process.py
    #          util.info('child process calling self.run()')
    #          try:
    #              self.run()">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def run(self):
        '''
        to be run in sub-process; can be overridden in sub-class
        '''
        # -----------------------------------------------------------------------------------------
        #       
        # -----------------------------------------------------------------------------------------
        class2print = "Process4Xi"
        method2print = "run"
        
        message2print = "{started" + "; run-of-Process4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 06:54:53 01/16/13 Pacific Standard Time; 05:03:43 01/17/13 Pacific Standard Time
           
        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal: OK         
            # -----------------------------------------------------------------------------------------        
       
            message2print = "{(StepOriginal) calling" + "; Process-run-calling-by-run-of-Process4Xi: " + str(Process.run) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
                            
                            
            Process.run(self)
        else:
            # -----------------------------------------------------------------------------------------
            # Step (1/2) OK4HW  
            # -----------------------------------------------------------------------------------------        
            if self._target:
                message2print = "{Step (1/2a) calling" + "; target-of-process2xi-calling-by-run-of-Process4Xi: " + str(self._target) + "; time: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)       
                # <function sense at 0x0000000003CCC8C8>; <function worker4xi at 0x0000000003C4CE18>
                                                   
                self._target(*self._args, **self._kwargs)

                message2print = "{Step (1/2b) performed" + "; target-of-process2xi-performed-by-run-of-Process4Xi: " + str(self._target) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <function sense at 0x0000000003CCC8C8>        
            else:
                message2print = "{analyzed" + "; target-analyzed-by-run-of-Process4Xi: " + str(None) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                                
               
            # -----------------------------------------------------------------------------------------
            # Step (2/2) OK4HW       
            # -----------------------------------------------------------------------------------------            
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others 
            
            message2print = "{Step (2/2) returning" + "; run-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 06:54:54 01/16/13 Pacific Standard Time     

    #</methodize4xi>
            
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "start-of-Process4Xi" usage = "    
    #    Start the process activity.
    #    This must be called at most once per process object. 
    #    It arranges for the object run() method to be invoked in a separate process.
    #
    #    managers.py:
    #         self._process = Process(...
    #         ident = ':'.join(str(i) for i in self._process._identity)
    #         self._process.name = type(self).__name__  + '-' + ident
    #         self._process.start()
    #">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def start(self):
        '''
        Process4Xi start method: starts a child process
        '''
                               
        class2print = "Process4Xi"
        method2print = "start"       
        
        message2print = "{started" + "; start-of-Process4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 06:54:55 01/16/13 Pacific Standard Time
        
        # -----------------------------------------------------------------------------------------                        
        #
        # -----------------------------------------------------------------------------------------
                     
        if examine4xi(class2print, method2print):
            # ----------------------------------------------------------------------------------- ------
            # StepOriginal: OK        
            # -----------------------------------------------------------------------------------------        
            message2print = "{(StepOriginal) calling" + "; Process-start-calling-by-start-of-Process4Xi: " + str(Process.start) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
            # { Process4Xi : start ; StepOriginal calling; function: original Process.start(self) time: 08:01:24 09/02/09 FLE Daylight Time}
            
            Process.start(self)
        else:        
            
            # -----------------------------------------------------------------------------------------
            # (Step 1/7): twice starting    
            # ----------------------------------------------------------------------------------------
        
            if self._popen is None:  # it's allowed to start a process only once
    
                message2print = "{(Step 1/7a) accepted" + "; popen-of-process2xi-accepted-by-start-of-Process4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # None         
                
            else:
                message2print = "{(Step 1/7b) warned" + "; popen-of-process2xi-warned-by-start-of-Process4Xi: " + " ** " + str(self._popen)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                message2print = "{(Step 1/7c) informed" + "; starting-twice-informed-by-start-of-Process4Xi: " + " ** it is allowed to start a process only once ** "  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
            
                omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
                message2print = "{(Step 1/7d) returning" + "; start-of-Process4Xi-returning: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                
                return
                 
            # -----------------------------------------------------------------------------------------
            # (Step 2/7): pid
            # ----------------------------------------------------------------------------------------
    
            pid2xi = os.getpid()
    
            message2print = "{(Step 2/7a) got" + "; pid2xi-got-by-start-of-Process4Xi: " + str(pid2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 2220              
            
            
            if self._parent_pid == pid2xi: 
    
                message2print = "{(Step 2/7b) accepted" + "; parent-pid-of-process2xi-accepted-by-start-of-Process4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # 2220
            else:
                message2print = "{(Step 2/7c) warned" + "; pid2xi-of-process2xi-warned-by-start-of-Process4Xi: " + " ** " + str(pid2xi)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                message2print = "{(Step 2/7d) warned" + "; starting-wrong-object-warned-by-start-of-Process4Xi: " + " ** you can only start a process object created by current process ** "  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
            
                omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
                message2print = "{(Step 2/7e) returning" + "; start-of-Process4Xi-returning: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                
                return                
                           
            # -----------------------------------------------------------------------------------------
            # (Step 3/7): deamonic  
            # -----------------------------------------------------------------------------------------
            daemonic2xi = get_daemonic_current_process4xi()
    
            message2print = "{(Step 3/7a) got" + "; daemonic2xi-got-by-start-of-Process4Xi: " + str(daemonic2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # False          

            if not daemonic2xi:                                       

                message2print = "{(Step 3/7b) accepted" + "; daemonic2xi-accepted-by-start-of-Process4Xi: " + str(daemonic2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # False               
            else:
                message2print = "{(Step 3/7c) warned" + "; daemonic2xi-of-process2xi-warned-by-start-of-Process4Xi: " + " ** " + str(daemonic2xi)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                message2print = "{(Step 3/7d) warned" + "; daemonic-can-not-have-children-warned-by-start-of-Process4Xi: " + " ** daemonic processes are not allowed to have children ** "  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
            
                omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
                message2print = "{(Step 3/7e) returning" + "; start-of-Process4Xi-returning: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                
                return                
                                       
          
            
            # -----------------------------------------------------------------------------------------
            # (Step 4/7): cleanup
            # ----------------------------------------------------------------------------------------
            message2print = "{(Step 4/7a) calling" + "; cleanup4xi-calling-by-start-of-Process4Xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
            # <function _cleanup4xi at 0x00000000035A8EA0>                
                            
            _cleanup4xi() #embedded function to check for processes which have finished and to discard from child list
    
            message2print = "{(Step 4/7a) performed" + "; cleanup4xi-performed-by-start-of-Process4Xi: " + str(_cleanup4xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # <function _cleanup4xi at 0x00000000035A8EA0>             

            
            # -----------------------------------------------------------------------------------------
            # (Step 5/7): Popen4Xi   
            # ----------------------------------------------------------------------------------------
            message2print = "{(Step 5/7a) checking" + "; Popen-of-process2xi-checking-by-start-of-Process4Xi: " + str(self._Popen) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)           
            # None                                             

            
            if self._Popen is not None:              # process attribute exists
                Popen4Xi = self._Popen               # set class to equal existing one
                
                message2print = "{(Step 5/7b) set" + "; Popen4Xi-set-by-start-of-Process4Xi to: " + str(Popen4Xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                

            else:
                from popen4xi import Popen4Xi        # __init__ has set to None, use Popen4Xi
                
                message2print = "{(Step 5/7c) imported" + "; Popen4Xi-imported-by-start-of-Process4Xi: " + str(Popen4Xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                # <class 'popen4xi.Popen4Xi'>     

                
            message2print = "{(Step 5/7d) calling" + "; Popen4Xi-calling-by-start-of-Process4Xi: " + str(Popen4Xi) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
            # <class 'popen4xi.Popen4Xi'>    
            
            self._popen = Popen4Xi(self)            
            
            
            message2print = "{(Step 5/7e) set" + "; popen-of-process2xi-set-by-start-of-Process4Xi to: " + str(self._popen)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # <popen4xi.Popen4Xi object at 0x000000000393CE80>  

                            
            # -----------------------------------------------------------------------------------------
            # (Step 6/7): add child   
            # ----------------------------------------------------------------------------------------
            self._sentinel = self._popen.sentinel
            message2print = "{(Step 6/7a) set" + "; sentinel-of-process2xi-set-by-start-of-Process4Xi to: " + str(self._sentinel)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            # 596 
            
            message2print = "{(Step 6/7b) adding" + "; process2xi-adding-by-start-of-Process4Xi: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 06:54:56 01/16/13 Pacific Standard Time            
            
            add_child_current_process4xi(self)       #dragonized _current_process._children.add(self)
    
            message2print = "{(Step 6/7c) added" + "; process2xi-added-by-start-of-Process4Xi: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 06:54:56 01/16/13 Pacific Standard Time
                         
                      
            message2print = "{(Step 6/7d) listed" + "; children-of-current-process-listed-by-start-of-Process4Xi: " + str(list_children_current_process4xi()) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)     
            # [<Process4Xi(PoolWorker4Xi-4, stopped daemon)>]                
            
                               
            # -----------------------------------------------------------------------------------------
            # (Step 7/7): done all start steps      
            # -----------------------------------------------------------------------------------------
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{(Step 7/7) returning" + "; start-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 06:54:56 01/16/13 Pacific Standard Time 
            
    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "terminate-of-Process4Xi" usage = "
    #    Terminates the process. 
    #    On Unix this is done using the SIGTERM signal; 
    #    On Windows TerminateProcess is used. 
    #    Note:
    #         exit handlers and finally clauses, etc., will not be executed.
    #         descendant processes of the process will not be terminated, they will simply become orphaned.
    #         more at python.org
    #
    # usage in multiprocessing:
    #     forking.py:
    #         process.terminate()
    #">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def terminate(self):
        '''
        Process4Xi terminate method: terminates process and sends SIGTERM signal or uses TerminateProcess()
        '''
        class2print = "Process4Xi"
        method2print = "terminate"

        message2print = "{started" + "; terminate-of-Process4Xi-started: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)   
        # 03:10:35 01/16/13 Pacific Standard Time
        
        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal: OK        
            # -----------------------------------------------------------------------------------------        
            message2print = "{(StepOriginal) calling" + "; Process-terminate-calling-by-terminate-of-Process4Xi: " + str(Process.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
            # { Process4Xi : terminate ; StepOriginal calling original Process.terminate(self) time: 15:51:37 09/02/09 FLE Daylight Time}
            
            Process.terminate(self)
            
        else:                     
            # -----------------------------------------------------------------------------------------    
            # (Step 1/2) 
            # -----------------------------------------------------------------------------------------                 
            message2print = "{(Step 1/2a) commanding" + "; popen-terminate-of-process2xi-commanding-by-terminate-of-Process4Xi: " + str(self._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            # <bound method Popen4Xi.terminate of <popen4xi.Popen4Xi object at 0x000000000344DE10>>

                           
            self._popen.terminate()
            
            message2print = "{(Step 1/2b) performed" + "; popen-terminate-of-process2xi-performed-by-terminate-of-Process4Xi: " + str(self._popen.terminate) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # <bound method Popen4Xi.terminate of <popen4xi.Popen4Xi object at 0x000000000344DE10>>
                      
                
            
            # -----------------------------------------------------------------------------------------    
            # (Step 2/2) 
            # -----------------------------------------------------------------------------------------          
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{(Step 2/2) returning" + "; terminate-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 03:10:35 01/16/13 Pacific Standard Time     

    #</methodize4xi>
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "join-of-Process4Xi" usage = "
    #   join of Process4Xi: 
    #     Block the calling thread until the process whose join() method is called terminates or until the optional timeout occurs.
    #     Timeout is defined by the function from centrally defined knowledgebase - dragonized feature to avoid system tilts
    #     A process can be joined many times.
    #     A process cannot join itself because this would cause a deadlock. 
    #     It is an error to attempt to join a process before it has been started.
    #     read more at python.org
    # 
    # usage in multiprocessing:
    #     managers.py:
    #         for p in active_children():
    #             p.join()">
    #<state4xi status = "NACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def join(self, timeout=None):
        '''
        join method waits until child process terminates
        ''' 
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                 
        class2print = "Process4Xi"
        method2print = "join"
        
        message2print = "{started" + "; join-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:46:45 01/22/13 Pacific Standard Time          
        
        timeout = omega2timeout4xi(class2print, method2print) 

        message2print = "{set" + "; timeout-set-by-join-of-Process4Xi to: " + str(timeout)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 0.4
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     

        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal   
            # -----------------------------------------------------------------------------------------        
            message2print = "{(StepOriginal) calling" + "; Process-join-calling-by-join-of-Process4Xi: " + str(Process.join) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)       
            # { Process4Xi : join ; StepOriginal calling original Process.join(self, timeout) time: 15:34:35 09/02/09 FLE Daylight Time}
            
            Process.join(self, timeout)
        else:                 
   
            # -----------------------------------------------------------------------------------------    
            # (Step 1/5)
            # -----------------------------------------------------------------------------------------  
            if self._parent_pid == os.getpid():  
            
                message2print = "{(Step 1/5a) accepted" + "; parent-pid-of-process2xi-accepted-by-join-of-Process4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                 
                # 4240
            else:
            
                message2print = "{(Step 1/5b) warned" + "; parent-pid-of-process2xi-warned-by-join-of-Process4Xi: " + " ** " + str(self._parent_pid)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                message2print = "{(Step 1/5c) informed" + "; parent-pid-informed-by-join-of-Process4Xi: " + " ** one can only join a child process ** "  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
            
                omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
                message2print = "{(Step 1/5d) returning" + "; join-of-Process4Xi-returning: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                
                return                
                
                        
            # -----------------------------------------------------------------------------------------    
            # (Step 2/5)
            # -----------------------------------------------------------------------------------------          
            if self._popen is not None: # one can only join a started process
            
                message2print = "{(Step 2/5a) accepted" + "; popen-of-process2xi-accepted-by-join-of-Process4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                  
                # <popen4xi.Popen4Xi object at 0x000000000344DE10>
            else:
            
                message2print = "{(Step 2/5b) warned" + "; popen-of-process2xi-of-process2xi-warned-by-join-of-Process4Xi: " + " ** " + str(self._popen)  + " ** " + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
                message2print = "{(Step 2/5c) informed" + "; joining-of-process2xi-informed-by-join-of-Process4Xi: " + " ** one can only join a started process ** "  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
            
                omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
                message2print = "{(Step 2/5d) returning" + "; join-of-Process4Xi-returning: " + time4xi() + "}" 
                print4xi(class2print, method2print, message2print)
                
                return            
                    
            # -----------------------------------------------------------------------------------------    
            # (Step 3/5)
            # -----------------------------------------------------------------------------------------          
            message2print = "{(Step 3/5a) passing" + "; timeout-passing-to-popen-wait-of-process2xi-by-join-of-Process4Xi: " + str(timeout) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)            
            # 0.2 <-- 0.4 05:46:45 01/22/13 Pacific Standard Time
            
            response2xi = self._popen.wait(timeout)
     
            message2print = "{(Step 3/5b) got" + "; response2xi-got-by-join-of-Process4Xi: " + str(response2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # 0               
            
                    
            # -----------------------------------------------------------------------------------------    
            # (Step 4/5)
            # -----------------------------------------------------------------------------------------          
            if response2xi is not None:
            
                message2print = "{(Step 4/5a) discarding" + "; process2xi-discarding-by-join-of-Process4Xi: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 05:46:45 01/22/13 Pacific Standard Time            
            
                discard_child_current_process4xi(self)                   #dragonized
                
                message2print = "{(Step 4/5b) performed" + "; discard-child-current-process4xi-performed-by-join-of-Process4Xi: " + str(discard_child_current_process4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <function discard_child_current_process4xi at 0x0000000002CA2BF8>
            
            # -----------------------------------------------------------------------------------------    
            # (Step 5/5)
            # ----------------------------------------------------------------------------------------- 
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{(Step 5/5) returning" + "; join-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)                
            # 05:46:45 01/22/13 Pacific Standard Time
            
    #</methodize4xi>
          
                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "is-alive-of-Process4Xi" usage = "
    #   Return whether the process is alive.
    #   Roughly, a process object is alive from the moment the start() method returns
    #   until the child process terminates
    #   more: python.org
    #  
    #   managers.py:
    #       if process.is_alive():
    #">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def is_alive(self):
        '''
        returns whether process is alive
        '''
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
                
        class2print = "Process4Xi"
        method2print = "is_alive"

        message2print = "{started" + "; is-alive-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 05:46:45 01/22/13 Pacific Standard Time
           
        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal: OK        
            # -----------------------------------------------------------------------------------------        
            message2print = "{(StepOriginal) returning" + "; Process-is-alive-function-returning-by-is-alive-of-Process4Xi: " + str(Process.is_alive) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # { Process4Xi : is_alive ; StepOriginal returning with original Process.is_alive(self) time: 08:01:24 09/02/09 FLE Daylight Time}
            
            return Process.is_alive(self)
            
        else:
        
            # -----------------------------------------------------------------------------------------    
            # (Step 1/6)
            # -----------------------------------------------------------------------------------------           
            Process4Xi._ack2current = False
            Process4Xi._nack2current = True
            
            self.ack2alive = False                                   # re-entrant object info
            
            message2print = "{(Step 1/6a) set" + "; ack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.ack2alive)  + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            # False
            
            self.nack2alive = True                                   # re-entrant object info

            message2print = "{(Step 1/6b) set" + "; nack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.nack2alive)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)    
            # True
              
            # -----------------------------------------------------------------------------------------    
            # continuing after having assumed that process object is NOT alive   
            # -----------------------------------------------------------------------------------------                          
            try:
                current_process2xi = get_current_process4xi()
            
                message2print = "{(Step 1/6a) got" + "; current-process2xi-got-by-is-alive-of-Process4Xi: " + str(current_process2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # <_MainProcess4Xi(MainProcess4Xi, started)>
                

                Process4Xi._nack2current = False
                
                message2print = "{(Step 1/6b) set" + "; nack2current-of-Process4Xi-set-by-is-alive-of-Process4Xi to: " + str(Process4Xi._nack2current)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # False
                
                Process4Xi._ack2current = True
                
                message2print = "{(Step 1/6c) set" + "; ack2current-of-Process4Xi-set-by-is-alive-of-Process4Xi to: " + str(Process4Xi._ack2current)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                   
                # True
                
            except:
                message2print = "{(Step 1/6d) yielded" + "; nack2current-yielded-by-is-alive-of-Process4Xi: " + str(Process4Xi._nack2current)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                
            # -----------------------------------------------------------------------------------------    
            # (Step 2/6)
            # -----------------------------------------------------------------------------------------         
            if Process4Xi._ack2current is True:
                # -------------------------------------------------------------------------------------    
                # contact to current process ok
                # -------------------------------------------------------------------------------------             
                if self is current_process2xi:                       # this process object is the object of current process

                    self.nack2alive = False                          
                    
                    message2print = "{(Step 2/6a) set" + "; nack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.nack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
 
                    self.ack2alive = True
                    
                    message2print = "{(Step 2/6b) set" + "; ack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.ack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                else:
                    message2print = "{(Step 2/6c) analyzed" + "; nack2current-of-Process4Xi-analyzed-by-is-alive-of-Process4Xi: " + str(Process4Xi._nack2current)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # False
            else:
                pass     
                                        
            # -----------------------------------------------------------------------------------------    
            # (Step 3/6)
            # -----------------------------------------------------------------------------------------         
            if self.ack2alive is True:
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------             
                pass
            else:
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------                     
                if self._parent_pid == os.getpid():                      
                    # ---------------------------------------------------------------------------------    
                    # can only test a child process
                    # ---------------------------------------------------------------------------------

                    message2print = "{(Step 3/6a) accepted" + "; parent-pid-of-process2xi-accepted-by-is-alive-of-Process4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                    # 4240
                                    
                    message2print = "{(Step 3/6b) accepted" + "; current-process-as-process-object-creator-accepted-by-is-alive-of-Process4Xi: " + str(self._parent_pid) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    # 4240
                else:
                    message2print = "{(Step 3/6c) yielded" + "; parent-pid-of-process2xi-yielded-by-is-alive-of-Process4Xi: " + str(self._parent_pid)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print) 
                                                            
            
            
            # -----------------------------------------------------------------------------------------    
            # (Step 4/6)  
            # -----------------------------------------------------------------------------------------                 
            if self.ack2alive is True:
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------             
                pass
            else:    
                if self._popen is None:
                    pass
                else:
                    # ---------------------------------------------------------------------------------    
                    # 
                    # ---------------------------------------------------------------------------------
                                         
                    message2print = "{(Step 4/6a) got" + "; popen-of-process2xi-got-by-is-alive-of-Process4Xi: " + str(self._popen)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                    #HW: <popen4xi.Popen4Xi object at 0x02D32450>; time: 03:27:24 04/23/10 Pacific Daylight Time
                                
                
                    self.nack2alive = False                          # re-entrant object info
                    
                    message2print = "{(Step 4/6b) set" + "; nack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.nack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    #HW: False; time: 03:27:24 04/23/10 Pacific Daylight Time
                    
                    self.ack2alive = True
                    
                    message2print = "{(Step 4/6c) set" + "; ack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.ack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)                        
                    #HW: True; time: 03:27:24 04/23/10 Pacific Daylight Time
                    
            # -----------------------------------------------------------------------------------------     
            # (Step 5/6)
            # -----------------------------------------------------------------------------------------         
            if self.ack2alive is False:
                # -------------------------------------------------------------------------------------    
                # 
                # -------------------------------------------------------------------------------------             
                pass
            else:                
                # -------------------------------------------------------------------------------------    
                # poll the process object to make sure it answers
                # ------------------------------------------------------------------------------------- 
                            
                message2print = "{(Step 5/6a) calling" + "; popen-poll-of-process2xi-calling-by-is-alive-of-Process4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                # <bound method Popen4Xi.poll of <popen4xi.Popen4Xi object at 0x000000000339C550>>
    
                
                self._popen.poll()
                
                message2print = "{(Step 5/6b) polled" + "; popen-poll-of-process2xi-polled-by-is-alive-of-Process4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)   
                # <bound method Popen4Xi.poll of <popen4xi.Popen4Xi object at 0x000000000339C550>>

                returncode2xi = self._popen.returncode
                
                message2print = "{(Step 5/6c) got" + "; returncode2xi-got-by-is-alive-of-Process4Xi: " + str(returncode2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # 0
                
                if returncode2xi:
                    # ---------------------------------------------------------------------------------    
                    # any return code will do because the called one has bugs !
                    # ---------------------------------------------------------------------------------
                                         
                    self.nack2alive = False                          # re-entrant object info
                    
                    message2print = "{(Step 5/6d) set" + "; nack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.nack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
 
                    self.ack2alive = True
                    
                    message2print = "{(Step 5/6e) set" + "; ack2alive-of-process2xi-set-by-is-alive-of-Process4Xi to: " + str(self.ack2alive)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)
                else:
                    pass                                        
            
            # -----------------------------------------------------------------------------------------    
            # (Step 6/6)
            # -----------------------------------------------------------------------------------------         
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{(Step 6/6) returning" + "; ack2alive-of-process2xi-returning-by-is-alive-of-Process4Xi: " + str(self.ack2alive) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            # True          

            
            return self.ack2alive
            
    #</methodize4xi>
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-property-of-Process4Xi" usage = "returns process name
    # example: print("(STEP 2.7A/33) OF TEST_CURRENT_PROCESS4XI.PY - PHASE3(): JOINING THE PROCESS: ", process2xi.name)  # Process4Xi-1
    # ">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def name(self):
        '''
        Process4Xi name method: returns process name
        '''
        class2print = "Process4Xi"
        method2print = "name"
        
        message2print = "{started" + "; name-property-of-Process4Xi-started: " + time4xi() + "}"  
        print4xi(class2print, method2print, message2print)   
        # 05:46:44 01/22/13 Pacific Standard Time         
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                         
        message2print = "{returning" + "; name-property-of-process2xi-returning-by-name-of-Process4Xi: " + str(self._name) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # Process4Xi-1
        
        return self._name
        
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "name-setter-of-Process4Xi" usage = "Sets the process name">
    #<state4xi status = "NACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @name.setter
    def name(self, name):
        '''
        Process4Xi name method: sets process name 
        '''
        class2print = "Process4Xi"
        method2print = "name"

        message2print = "{started" + "; name-setter-of-Process4Xi-started: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 06:54:56 01/16/13 Pacific Standard Time
                                        
        message2print = "{passed" + "; name-passed-to-name-setter-of-Process4Xi: " + str(name) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # PoolWorker4Xi-5

        
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
        if isinstance(name, str):
            
            message2print = "{accepted" + "; name-accepted-by-name-setter-of-Process4Xi: " + str(name) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)             
            # PoolWorker4Xi-5
        else:
            message2print = "{warned" + "; name-warned-by-name-setter-of-Process4Xi: " + " ** " + str(name)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
            message2print = "{informed" + "; name-informed-by-name-setter-of-Process4Xi: " + " ** process name must be a string ** "  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
            
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{returning" + "; name-setter-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)
                
            return        
            
            
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        self._name = name

        message2print = "{set" + "; name-of-process2xi-set-by-name-setter-of-Process4Xi to: " + str(self._name)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # PoolWorker4Xi-5
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{returning" + "; name-setter-of-Process4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 06:54:56 01/16/13 Pacific Standard Time
        
    #</methodize4xi>
            
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-property-of-Process4Xi" usage = "Return the process daemon flag., which is a boolean.">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def daemon(self):
        '''
        Process4Xi daemon method: returns whether process is a daemon
        '''
        class2print = "Process4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-property-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 06:54:56 01/16/13 Pacific Standard Time
                                 
        message2print = "{returning" + "; daemonic-of-process2xi-returning-by-daemon-property-of-Process4Xi: " + str(self._daemonic) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # True
                                
        return self._daemonic
    #</methodize4xi>
            
           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "daemon-setter-of-Process4Xi" usage = "Sets the process daemon flag">
    #<state4xi status = "NACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @daemon.setter
    def daemon(self, daemonic):
        '''
        Process4Xi daemon method: sets process daemonic
        '''
        class2print = "Process4Xi"
        method2print = "daemon"
        
        message2print = "{started" + "; daemon-setter-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 06:54:57 01/16/13 Pacific Standard Time
                       
        message2print = "{passed" + "; daemonic-passed-to-daemon-setter-of-Process4Xi: " + str(daemonic) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # True
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        if self._popen is None: 
        
            message2print = "{accepted" + "; popen-of-process2xi-accepted-by-daemon-setter-of-Process4Xi: " + str(self._popen) + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # None             
        else:
            
            message2print = "{warned" + "; popen-of-process2xi-warned-by-daemon-setter-of-Process4Xi: " + " ** " + str(self._popen)  + " ** " + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
                
            message2print = "{informed" + "; popen-informed-by-daemon-setter-of-Process4Xi: " + " ** process has already started ** "  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)        
            
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{returning" + "; daemon-setter-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)
                
            return                             
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        self._daemonic = daemonic

        message2print = "{set" + "; daemonic-of-process2xi-set-by-daemon-setter-of-Process4Xi to: " + str(self._daemonic)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        # True        
                                
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; daemon-setter-of-Process4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        # 06:54:57 01/16/13 Pacific Standard Time                
                
                        
    #</methodize4xi>
                
                
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-property-of-Process4Xi" usage = "Returns the process authentication key (a byte string)">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def authkey(self): 
        '''
        Process4Xi authkey method: return authorization key
        '''
        class2print = "Process4Xi"
        method2print = "authkey"

        message2print = "{started" + "; authkey-property-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 06:54:54 01/16/13 Pacific Standard Time                  

                
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; authkey-of-process2xi-returning-by-authkey-property-of-Process4Xi: " + str(self._authkey) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # b'<\xa1\x0f3N\x1e\x06\x95]\xf7\xde\xfd\x91\x1d\xae)\xee\x81\xd4\xd05$&Ge\xe2& \xef*\x96Q'
       
        
        return self._authkey
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "authkey-setter-of-Process4Xi" usage = "
    #   Return the process authentication key (a byte string).
    #   When multiprocessing is initialized the main process is assigned a random string using os.random().
    #   When a Process object is created, it will inherit the authentication key of its parent process, although this may be changed
    #">    
    #<state4xi status = "NACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @authkey.setter
    def authkey(self, authkey):
        '''
        Process4Xi authkey method: sets authorization key
        '''
        message2print = "{started" + "; authkey-setter-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
                        
        self._authkey = os.urandom(32)  
        
        message2print = "{set" + "; authkey-of-process2xi-set-by-authkey-setter-of-Process4Xi to: " + str(self._authkey)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
                
                            
    #</methodize4xi>
                
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "exitcode-property-of-Process4Xi" usage = "
    #     Return the child exit code. 
    #     This will be None if the process has not yet terminated. 
    #     A negative value -N indicates that the child was terminated by signal N.
    #">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def exitcode(self):
        '''
        Process4Xi exicode method: returns exit code of process or `None` if it has yet to stop
        '''
        class2print = "Process4Xi"
        method2print = "exitcode"
        
        message2print = "{started" + "; exitcode-property-of-Process4Xi-started: "  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 06:54:54 01/16/13 Pacific Standard Time          

        
            
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        if self._popen is None:
            message2print = "{returning" + "; popen-of-process2xi-returning-by-exitcode-property-of-Process4Xi: " + str(self._popen) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
                         
        
            return self._popen
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; popen-poll-function-of-process2xi-returning-by-exitcode-property-of-Process4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
        # <bound method Popen4Xi.poll of <popen4xi.Popen4Xi object at 0x000000000393C5C0>>
        

        return self._popen.poll()  
    #</methodize4xi>
                   
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ident-property-of-Process4Xi" usage = "ident of Process4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def ident(self):
        '''
        Process4Xi ident method: returns indentifier (PID) of process or `None` if it has yet to start
        '''
        class2print = "Process4Xi"
        method2print = "ident"
        
        message2print = "{started" + "; ident-property-of-Process4Xi-started: " + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 09:33:04 01/16/13 Pacific Standard Time       
 
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        if self is get_current_process4xi():
            message2print = "{returning" + "; pid-returning-by-ident-property-of-Process4Xi: " + str(os.getpid()) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
           
            return os.getpid()
        else:
            message2print = "{returning" + "; pid-anded-returning-by-ident-property-of-Process4Xi: " + str(self._popen and self._popen.pid) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            # 5388               
        
            return self._popen and self._popen.pid
        
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sentinel-property-of-Process4Xi" usage = "sentinel of Process4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    @property
    def sentinel(self):
        '''
        Return a file descriptor (Unix) or handle (Windows) suitable for
        waiting for process termination.
        '''
        class2print = "Process4Xi"
        method2print = "sentinel"
        
        message2print = "{started" + "; sentinel-property-of-Process4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        #                
 
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------         
        try:
            message2print = "{returning" + "; sentinel-of-process2xi-returning-by-sentinel-property-of-Process4Xi: " + str(self._sentinel) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            
            return self._sentinel
        
        except AttributeError:

        
            raise ValueError("sentinel of Process4Xi - process not started!")
            
        # -----------------------------------------------------------------------------------------    
        #
        # ----------------------------------------------------------------------------------------- 
        
    #</methodize4xi>    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "repr-of-Process4Xi" usage = "presentation or Process4Xi">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def __repr__(self):
        '''
        Process4Xi __repr__ method: 
        '''
        class2print = "Process4Xi"
        method2print = "__repr__"
        
        message2print = "{started" + "; repr-of-Process4Xi-started: "  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)   
        # 05:35:38 01/16/13 Pacific Standard Time
        

        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal: OK        
            # -----------------------------------------------------------------------------------------        

            message2print = "{(StepOriginal) returning" + "; Process-repr-function-returning-by-repr-of-Process4Xi: " + str(Process.__repr__) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # { Process4Xi : __repr__ ; StepOriginal returning by calling original Process.__repr__ time: 08:01:24 09/02/09 FLE Daylight Time}             
            
            return Process.__repr__(self)
        else:
            # -----------------------------------------------------------------------------------------    
            # (Step 1/3): OK4ORIGINAL
            # -----------------------------------------------------------------------------------------         
            if self is get_current_process4xi():
                status = Process4Xi._constant_p2xi.get_started_process()                                                       #'started' dragonized STARTED_PROCESS4XI
                
                message2print = "{(Step 1/3a) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                                
                                
            elif self._parent_pid != os.getpid():
                status = Process4Xi._constant_p2xi.get_unknown_process()                                                       #'unknown' dragonized UNKNOWN_PROCESS4XI
                                
                message2print = "{(Step 1/3b) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
   
            elif self._popen is None:
                status = Process4Xi._constant_p2xi.get_initial_process()                                                       #'initial' dragonized INITIAL_PROCESS4XI
                                
                message2print = "{(Step 1/3c) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # 05:35:38 01/16/13 Pacific Standard Time
                
            else:
                message2print = "{(Step 1/3d1) calling" + "; popen-poll-of-popen2xi-calling-by-repr-of-Process4Xi: " + str(self._popen.poll) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
            
                if self._popen.poll() is not None:
                    status = self.exitcode
                                    
                    message2print = "{(Step 1/3d2) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    #Pipe1: o 
                else:
                    status = Process4Xi._constant_p2xi.get_started_process()                                                   #'started' dragonized STARTED_PROCESS4XI
                            
                    message2print = "{(Step 1/3e) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
   
                    
            # -----------------------------------------------------------------------------------------    
            # (Step 2/3): OK4ORIGINAL
            # ----------------------------------------------------------------------------------------- 
            if type(status) is int:
    
                message2print = "{(Step 2/3a) decided" + "; type-status-decided-by-repr-of-Process4Xi: " + str(type(status)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)        
                # <class 'int'>
                
                if status == 0:

                               
                    status = Process4Xi._constant_p2xi.get_stopped_process()                                                   #'stopped' dragonized STOPPED_PROCESS4XI
                    
                    message2print = "{(Step 2/3b) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # stopped
                                    
                    
                else:
                    status = 'stopped[%s]' % Process4Xi._constant_p2xi.get_exitcode_to_name(status, status)                    # dragonized _exitcode_to_name.get(status, status) 
            
                    message2print = "{(Step 2/3c) set" + "; status-set-by-repr-of-Process4Xi to: " + str(status)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                
                              
                    
            # -----------------------------------------------------------------------------------------    
            # (Step 3/3): OK4ORIGINAL
            # ----------------------------------------------------------------------------------------- 
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{(Step 3/3 ) returning" + "; repr-of-Process4Xi-returning: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print) 
            # 05:35:38 01/16/13 Pacific Standard Time
            
            return '<%s(%s, %s%s)>' % (type(self).__name__, self._name,
                                   status, self._daemonic and ' daemon' or '')
            # -----------------------------------------------------------------------------------------    
            #
            # ----------------------------------------------------------------------------------------- 
    #</methodize4xi>
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "bootstrap-of-Process4Xi" usage = "
    # forking.py:
    #     code = process_obj._bootstrap()
    #">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    #
    def _bootstrap(self):
        '''
        Process4Xi _bootstrap method: bootstrap; defines global objects
        ''' 
        # -----------------------------------------------------------------------------------------    
        # StepOriginal: OK, OK4ORIGINAL
        # ----------------------------------------------------------------------------------------- 
        class2print = "Process4Xi"
        method2print = "_bootstrap"

        message2print = "{started" + "; bootstrap-of-Process4Xi-started: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 09:24:36 01/16/13 Pacific Standard Time                      
        
        
        if examine4xi(class2print, method2print):
            # -----------------------------------------------------------------------------------------
            # StepOriginal  
            # -----------------------------------------------------------------------------------------        
            message2print = "{(StepOriginal) returning" + "; Process-bootstrap-function-returning-by-bootstrap-of-Process4Xi: " + str(Process._bootstrap) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)  
            # { Process4Xi : _bootstrap ; StepOriginal returning by calling original Process._bootstrap time: 09:57:52 09/02/09 FLE Daylight Time}
            
            return Process._bootstrap(self)        
        else:
         
            # -----------------------------------------------------------------------------------------    
            # 
            # -----------------------------------------------------------------------------------------                 
            try:
                # -------------------------------------------------------------------------------------
                # (Step 1/12)
                # ------------------------------------------------------------------------------------- 

                message2print = "{(Step 1/12a) used" + "; cf2xi-used-by-bootstrap-of-Process4Xi: " + str(Process4Xi._cf2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print) 
                # <constant_family4xi.ConstantFamily4Xi object at 0x0000000002D54940>                
                    
                inet2xi = Process4Xi._cf2xi.get_af_inet()
                
                message2print = "{(Step 1/12b) set" + "; inet2xi-set-by-bootstrap-of-Process4Xi to: " + str(inet2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # AF_INET
                  
                unix2xi = Process4Xi._cf2xi.get_af_unix()
                
                message2print = "{(Step 1/12c) set" + "; unix2xi-set-by-bootstrap-of-Process4Xi to: " + str(unix2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # AF_UNIX
                  
                pipe2xi = Process4Xi._cf2xi.get_af_pipe()
                
                message2print = "{(Step 1/12d) set" + "; pipe2xi-set-by-bootstrap-of-Process4Xi to: " + str(pipe2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # AF_PIPE
                                  
                family2xi = Process4Xi._cf2xi.get_default_family()
                
                message2print = "{(Step 1/12e) set" + "; family2xi-set-by-bootstrap-of-Process4Xi to: " + str(family2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # AF_PIPE
                
                families2xi = Process4Xi._cf2xi.get_families()
                
                message2print = "{(Step 1/12f) set" + "; families2xi-set-by-bootstrap-of-Process4Xi to: " + str(families2xi)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # ['AF_INET', 'AF_PIPE']

                                        
                # -------------------------------------------------------------------------------------
                # (Step 2/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------
                self._children = set()
    
                message2print = "{(Step 2/12) set" + "; children-of-process2xi-set-by-bootstrap-of-Process4Xi to: " + str(self._children)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # set()
                
                
                # -------------------------------------------------------------------------------------
                # (Step 3/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------            
                self._counter = itertools.count(1)
    
                message2print = "{(Step 3/12) set" + "; counter-of-process2xi-set-by-bootstrap-of-Process4Xi to: " + str(self._counter)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # count(1)
                
                
                
                # -------------------------------------------------------------------------------------
                # (Step 4/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------               
                message2print = "{(Step 4/12a) checking" + "; sys-stdin-checking-by-bootstrap-of-Process4Xi: " + str(sys.stdin) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)           
                # <_io.TextIOWrapper name='<stdin>' mode='r' encoding='cp437'>
                                
                if sys.stdin is not None:
                    try:
                        message2print = "{(Step 4/12b) passing" + "; fileno-passing-to-os-close-by-bootstrap-of-Process4Xi: " + str(sys.stdin.fileno()) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)            
                        # 0
                        
                        os.close(sys.stdin.fileno())
                        
                        message2print = "{(Step 4/12c) performed" + "; os-close-performed-by-bootstrap-of-Process4Xi: " + str(os.close) + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)             
                        # <built-in function close>
                                        
                    except (OSError, ValueError):
                        message2print = "{(Step 4/12d) hit" + "; OSError-ValueError-hit-by-bootstrap-of-Process4Xi: " + " *** sys-stdin-fileno: " + str(sys.stdin.fileno())  + " *** " + "; time: " + time4xi() + "}"
                        print4xi(class2print, method2print, message2print)
          
                        
                        pass
                        
                # -------------------------------------------------------------------------------------
                # (Step 5/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------            
                current_process2xi = CurrentProcess4Xi(True)  # dragonized _current_process = self; note that self passes hidden parameter and is True process object becoming the _current_process  
                
                message2print = "{(Step 5/12a) created" + "; current-process2xi-created-by-bootstrap-of-Process4Xi: " + str(current_process2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                # <current_process4xi.CurrentProcess4Xi object at 0x000000000350C2E8>
                
                message2print = "{(Step 5/12b) embedded" + "; process2xi-embedded-by-bootstrap-of-Process4Xi: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # 09:24:36 01/16/13 Pacific Standard Time
                
                                                             
                message2print = "{(Step 5/12c) got" + "; current-process-got-by-bootstrap-of-Process4Xi: " + str(current_process2xi.get_current())  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # <_MainProcess4Xi(MainProcess4Xi, started)>
                                
              
                message2print = "{(Step 5/12d) got" + "; name-current-process-got-by-bootstrap-of-Process4Xi: " + str(current_process2xi.get_name_current())  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
                # MainProcess4Xi
                                
                
                
                # -------------------------------------------------------------------------------------
                # (Step 6/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------  
                message2print = "{(Step 6/12a) passing" + "; type-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(type(_C4Xi().f)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <class 'method'>
                
                message2print = "{(Step 6/12b) passing" + "; reduce-method4xi-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(_reduce_method4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <function _reduce_method4xi at 0x0000000003595D08>
 
                
                ForkingPickler4Xi.register(type(_C4Xi().f), _reduce_method4xi)                    
                
                message2print = "{(Step 6/12c) passing" + "; type-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(type(list.append)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <class 'method_descriptor'>
                                                
                
                message2print = "{(Step 6/12d) passing" + "; reduce-method-descriptor4xi-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(_reduce_method_descriptor4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <function _reduce_method_descriptor4xi at 0x0000000003595950>
               
                
                ForkingPickler4Xi.register(type(list.append), _reduce_method_descriptor4xi)    
                
                
                message2print = "{(Step 6/12e) passing" + "; type-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(type(int.__add__)) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <class 'wrapper_descriptor'>
                                
                
                message2print = "{(Step 6/12f) passing" + "; reduce-method-descriptor4xi-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(_reduce_method_descriptor4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <function _reduce_method_descriptor4xi at 0x0000000003595950>;

                
                ForkingPickler4Xi.register(type(int.__add__), _reduce_method_descriptor4xi)    
                
                message2print = "{(Step 6/12g) passing" + "; partial-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(partial) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <class 'functools.partial'>
                                
                
                message2print = "{(Step 6/12h) passing" + "; reduce-partial4xi-passing-to-ForkingPickler4Xi-register-by-bootstrap-of-Process4Xi: " + str(_reduce_partial4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # <function _reduce_partial4xi at 0x00000000035957B8>
   
                
                                
                ForkingPickler4Xi.register(partial, _reduce_partial4xi)
                
                message2print = "{(Step 6/12i) performed" + "; ForkingPickler4Xi-register-performed-by-bootstrap-of-Process4Xi: " + str(ForkingPickler4Xi.register) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <bound method type.register of <class 'forkingpickler4xi.ForkingPickler4Xi'>>
                               

                
                            
                # -------------------------------------------------------------------------------------
                # (Step 7/12): OK4ORIGINAL
                # ------------------------------------------------------------------------------------- 
                message2print = "{(Step 7/12a) calling" + "; AfterFork4Xi-calling-by-bootstrap-of-Process4Xi: " + str(AfterFork4Xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                # <class 'after_fork4xi.AfterFork4Xi'>                
                                  
                
                af2xi = AfterFork4Xi()                           # dragonized; addded initialization of _afterfork_registry and _afterfork_counter
                
                message2print = "{(Step 7/12b) created" + "; af2xi-created-by-bootstrap-of-Process4Xi: " + str(af2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                # <after_fork4xi.AfterFork4Xi object at 0x000000000350C320>
                
                af2xi.init_all()
                
                message2print = "{(Step 7/12c) performed" + "; init-all-of-AfterFork4Xi-performed-by-bootstrap-of-Process4Xi: " + str(af2xi.init_all) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <bound method AfterFork4Xi.init_all of <after_fork4xi.AfterFork4Xi object at 0x000000000350C320>>
                                
                                   
                # -------------------------------------------------------------------------------------
                # (Step 8/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------
                message2print = "{(Step 8/12a) calling" + "; Finalizer4Xi-calling-by-bootstrap-of-Process4Xi: " + str(Finalizer4Xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)       
                # <class 'finalizer4xi.Finalizer4Xi'>
                
                f2xi = Finalizer4Xi()                            # dragonized using class
                
                message2print = "{(Step 8/12b) created" + "; f2xi-created-by-bootstrap-of-Process4Xi: " + str(f2xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)                 
                # <finalizer4xi.Finalizer4Xi object at 0x000000000350C2B0>
                
                f2xi.init_finalizer_registry()               
                
                message2print = "{(Step 8/12c) performed" + "; f2xi-init-finalizer-registry-performed-by-bootstrap-of-Process4Xi: " + str(f2xi.init_finalizer_registry) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <bound method Finalizer4Xi.init_finalizer_registry of <finalizer4xi.Finalizer4Xi object at 0x000000000350C2B0>>
                                
    
                
                # -------------------------------------------------------------------------------------
                # (Step 9/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------
                message2print = "{(Step 9/12a) passing" + "; false-passing-to-init-exiting4xi-by-bootstrap-of-Process4Xi: " + str(False) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)            
                # False
                
                init_exiting4xi(False)                                   # dragonized 
                
    
                message2print = "{(Step 9/12b) set" + "; exiting4xi-set-by-bootstrap-of-Process4Xi to: " + str(get_exiting4xi())  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                # False           

                
                # -------------------------------------------------------------------------------------
                # (Step 10/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------
                f2xi.clear_finalizer_registry()                          # dragonized 
                
                message2print = "{(Step 10/12) performed" + "; f2xi-clear-finalizer-registry-performed-by-bootstrap-of-Process4Xi: " + str(f2xi.clear_finalizer_registry) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <bound method Finalizer4Xi.clear_finalizer_registry of <finalizer4xi.Finalizer4Xi object at 0x000000000350C2B0>>
                
                
                # -------------------------------------------------------------------------------------
                # (Step 11/12): OK4ORIGINAL
                # -------------------------------------------------------------------------------------            
                _run_after_forkers4xi()
                
                message2print = "{(Step 11/12) performed" + "; run-after-forkers4xi-performed-by-bootstrap-of-Process4Xi: " + str(_run_after_forkers4xi) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                # <function _run_after_forkers4xi at 0x0000000003595D90>
                                
    
                
                # -------------------------------------------------------------------------------------
                # Step 12/12: OK4ORIGINAL
                # -------------------------------------------------------------------------------------  
                
                # _bootstrap child process calling self.run()
                
                message2print = "{(Step 12/12a) trying" + "; run-of-process2xi-trying-by-bootstrap-of-Process4Xi: " + str(self.run)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)         
                # <bound method Process4Xi.run of <Process4Xi(Process4Xi-1, stopped)>>

                
                try:
                    self.run()
                    
                    message2print = "{(Step 12/12b) performed" + "; run-of-process2xi-performed-by-bootstrap-of-Process4Xi: " + str(self.run) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    # <bound method Process4Xi.run of <Process4Xi(Process4Xi-1, stopped)>>
                                    
                    exitcode = 0
                    
                    
                    message2print = "{(Step 12/12c) set" + "; exitcode-set-by-bootstrap-of-Process4Xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                    # 0        
                                    
                     
                finally:
                    _exit_function4xi()  #<-- dragonized; run own exits, not registered for system exit (see util.py)
    
                    message2print = "{(Step 12/12d) performed" + "; exit-function4xi-performed-by-bootstrap-of-Process4Xi: " + str(_exit_function4xi) + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)             
                    # <function _exit_function4xi at 0x0000000003595E18>
                                    
                                                     
                # -------------------------------------------------------------------------------------
                # 
                # -------------------------------------------------------------------------------------              
                            
            except SystemExit as e:
                # -------------------------------------------------------------------------------------    
                #
                # -------------------------------------------------------------------------------------         
                        
                if not e.args:
                    exitcode = 1
                    
                    message2print = "{(Step 12/12e) set" + "; exitcode-set-by-bootstrap-of-Process4Xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                
                                    
                elif type(e.args[0]) is int:
                    exitcode = e.args[0]
                    
                    message2print = "{(Step 12/12f) set" + "; exitcode-set-by-bootstrap-of-Process4Xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                       
                else:
                    sys.stderr.write(e.args[0] + '\n')
                    sys.stderr.flush()
                    exitcode = 1
                    
                    message2print = "{(Step 12/12g) set" + "; exitcode-set-by-bootstrap-of-Process4Xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
                    print4xi(class2print, method2print, message2print)    
                       

                           
            # -----------------------------------------------------------------------------------------    
            #
            # -----------------------------------------------------------------------------------------                 
            except:

                
                exitcode = 1
                    
                message2print = "{(Step 12/12h) set" + "; exitcode-set-by-bootstrap-of-Process4Xi to: " + str(exitcode)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
                   
                
                
                import traceback
                
                sys.stderr.write('Process4Xi: _bootstrap(self): Process %s:\n' % self.name)
                
                message2print = "{(Step 12/12i) performed" + "; sys-stderr-write-performed-by-bootstrap-of-Process4Xi: " + str(sys.stderr.write) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                        
                
                
                sys.stderr.flush()
                
                message2print = "{(Step 12/12j) performed" + "; sys-stderr-flush-performed-by-bootstrap-of-Process4Xi: " + str(sys.stderr.flush) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                                
            
                traceback.print_exc()
                
                message2print = "{(Step 12/12k) performed" + "; traceback-print-exc-performed-by-bootstrap-of-Process4Xi: " + str(traceback.print_exc) + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)             
                             
                
            # -----------------------------------------------------------------------------------------    
            # OK4ORIGINAL
            # ----------------------------------------------------------------------------------------- 
            # _bootstrap exiting 
            omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
            
            message2print = "{returning" + "; exitcode-returning-by-bootstrap-of-Process4Xi: " + str(exitcode) + "; time: " + time4xi() + "}" 
            print4xi(class2print, method2print, message2print)    
            # 0               
            
            return exitcode
            
            # ---------------------------------------------------------------------------------------------
            # eof _bootstrap OK4ORIGINAL .i.e when __init__ with Process.__init__ 
            # ---------------------------------------------------------------------------------------------            
    #</methodize4xi>
        
        
                                       
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-Process4Xi" usage = "senses Process4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses Process4Xi class objects
        '''
        
        
        class2print = 'Process4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 09:24:36 01/16/13 Pacific Standard Time
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
       
        message2print = "{sensing" + "; Process4Xi-sensing-by-sense-of-Process4Xi: " + str(Process4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'process4xi.Process4Xi'>
                        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; knowledge-base2xi-got-by-sense-of-Process4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object': <Process4Xi(Process4Xi-1, stopped)>}
        
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['Popen-of-Process4Xi'] = Process4Xi._Popen
            kb2xi['identity-of-process2xi'] = self._identity             
            kb2xi['authkey-of-process2xi'] = self._authkey     
            kb2xi['daemonic-of-process2xi'] = self._daemonic
            kb2xi['tempdir-of-process2xi'] = self._tempdir             
            kb2xi['parent_pid-of-process2xi'] = self._parent_pid     
            kb2xi['popen-of-process2xi'] = self._popen        
            kb2xi['target-of-process2xi'] = self._target             
            kb2xi['args-of-process2xi'] = self._args     
            kb2xi['kwargs-of-process2xi'] = self._kwargs 
            kb2xi['name-of-process2xi'] = self._name             
                                                           
        except:
            message2print = "{yielded" + "; knowledge-base2xi-yielded-by-sense-of-Process4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
        
        
      
        message2print = "{sensed" + "; Process4Xi-sensed-by-sense-of-Process4Xi: " + str(Process4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        # <class 'process4xi.Process4Xi'>
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
        
        message2print = "{returning" + "; knowledge-base2xi-returning-by-sense-of-Process4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # {'popen-of-process2xi': <popen4xi.Popen4Xi object at 0x00000000034EDE10>, 'authkey-of-process2xi': b'Wg\xa8\x12\xee6H8\xd5\x0e\xb5\xae`Z\xe8\x83F\xc4\x04\xd1R\xf1\xb5rh\xa5B\x1e\xd5rEP', 
        #  'daemonic-of-process2xi': False, 'kwargs-of-process2xi': {}, 'parent_pid-of-process2xi': 5912, 'tempdir-of-process2xi': 'd:\\users\\ceo4dr~1\\appdata\\local\\temp\\pymp-23x8cn',
        #  'name-of-process2xi': 'Process4Xi-1', 'Popen-of-Process4Xi': None, 'target-of-process2xi': <function f4xi at 0x00000000035BA598>, 
        #  'object': <Process4Xi(Process4Xi-1, stopped)>, 'identity-of-process2xi': (1,),
        #  'args-of-process2xi': ()
        # }
        
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-Process4Xi" usage = "reasons Process4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons Process4Xi class objects
        '''
             
        
        class2print = 'Process4Xi'
        method2print = 'reason'

        message2print = "{started" + "; reason-of-Process4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 09:24:36 01/16/13 Pacific Standard Time      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; Process4Xi-reasoning-by-reason-of-Process4Xi: " + str(Process4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        # <class 'process4xi.Process4Xi'>
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{got" + "; knowledge-base4xi-got-by-reason-of-Process4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object-reason-object4xi': <Process4Xi(Process4Xi-1, stopped)>}
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; Process4Xi-reasoned-by-reason-of-Process4Xi: " + str(Process4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'process4xi.Process4Xi'>
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
        
        message2print = "{returning" + "; knowledge-base4xi-returning-by-reason-of-Process4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # {'object-reason-object4xi': <Process4Xi(Process4Xi-1, stopped)>}              
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-Process4Xi" usage = "aces Process4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces Process4Xi class objects 
        '''
              
        
        
        class2print = 'Process4Xi'
        method2print = 'ace'
        
        message2print = "{started" + ";  : " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        # 01/16/13 Pacific Standard Time                         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; Process4Xi-acing-by-ace-of-Process4Xi: " + str(Process4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        # <class 'process4xi.Process4Xi'>           
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; knowledge-base8xi-got-by-ace-of-Process4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        # {'object8xi': <Process4Xi(Process4Xi-1, stopped)>}


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; Process4Xi-aced-by-ace-of-Process4Xi: " + str(Process4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)      
        # <class 'process4xi.Process4Xi'>
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        omega2sleep4xi(class2print ,method2print)                # dragonized giving time to others
        
        message2print = "{returning" + "; knowledge-base8xi-returning-by-ace-of-Process4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
        # {'object8xi': <Process4Xi(Process4Xi-1, stopped)>}                
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_none4xi.txt
#   sense-test-none4xi.xml
#   reason-test-none4xi.xml
#   ace-test-none4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of process4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

